// Generated by gtkmmproc -- DO NOT MODIFY!


#include <libgnomevfsmm/drive.h>
#include <libgnomevfsmm/private/drive_p.h>

/* $Id: drive.ccg,v 1.2 2006/10/31 09:06:47 murrayc Exp $ */
// -*- C++ -*- // this is for the .ccg, I realize gensig puts one in

/* Copyright 2003 gnome-vfsmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <libgnomevfs/gnome-vfs-drive.h>
#include <libgnomevfs/gnome-vfs-enum-types.h>
#include <libgnomevfsmm/volume.h>

namespace Gnome
{

namespace Vfs
{

namespace
{

class SignalProxy_DriveOp
{
public:
  typedef Drive::OpSlot SlotType;

  SignalProxy_DriveOp(const SlotType& slot);
  ~SignalProxy_DriveOp();

  static void c_callback(gboolean succeeded, char* error, char* detailed_error, gpointer data);
  
protected:
  SlotType slot_;
};

SignalProxy_DriveOp::SignalProxy_DriveOp(const SlotType& slot)
: slot_(slot)
{}

SignalProxy_DriveOp::~SignalProxy_DriveOp()
{}

void SignalProxy_DriveOp::c_callback(gboolean succeeded, char* error, char* detailed_error, gpointer data)
{
  SignalProxy_DriveOp *const self = static_cast<SignalProxy_DriveOp*>(data);

  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  try
  {
  #endif //GLIBMM_EXCEPTIONS_ENABLED
    (self->slot_)(succeeded, Glib::ustring(error), Glib::ustring(detailed_error));
  #ifdef GLIBMM_EXCEPTIONS_ENABLED
  }
  catch(...)
  {
    Glib::exception_handlers_invoke();
  }
  #endif //GLIBMM_EXCEPTIONS_ENABLED
}

} //anonymous namespace

void Drive::mount(const OpSlot& slot)
{
  SignalProxy_DriveOp temp_proxy(slot);
  gnome_vfs_drive_mount(gobj(), &SignalProxy_DriveOp::c_callback, &temp_proxy);
}

void Drive::unmount(const OpSlot& slot)
{
  SignalProxy_DriveOp temp_proxy(slot);
  gnome_vfs_drive_unmount(gobj(), &SignalProxy_DriveOp::c_callback, &temp_proxy);
}

void Drive::eject(const OpSlot& slot)
{
  SignalProxy_DriveOp temp_proxy(slot);
  gnome_vfs_drive_eject(gobj(), &SignalProxy_DriveOp::c_callback, &temp_proxy);
}

} //namespace Vfs

} //namespace Gnome


namespace
{


static void Drive_signal_mounted_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0,void* data)
{
  using namespace Gnome::Vfs;
  typedef sigc::slot< void,const Glib::RefPtr<Volume>& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo Drive_signal_mounted_info =
{
  "volume-mounted",
  (GCallback) &Drive_signal_mounted_callback,
  (GCallback) &Drive_signal_mounted_callback
};


static void Drive_signal_pre_unmount_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0,void* data)
{
  using namespace Gnome::Vfs;
  typedef sigc::slot< void,const Glib::RefPtr<Volume>& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo Drive_signal_pre_unmount_info =
{
  "volume-pre-unmount",
  (GCallback) &Drive_signal_pre_unmount_callback,
  (GCallback) &Drive_signal_pre_unmount_callback
};


static void Drive_signal_unmounted_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0,void* data)
{
  using namespace Gnome::Vfs;
  typedef sigc::slot< void,const Glib::RefPtr<Volume>& > SlotType;

  // Do not try to call a signal on a disassociated wrapper.
  if(Glib::ObjectBase::_get_current_wrapper((GObject*) self))
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      if(sigc::slot_base *const slot = Glib::SignalProxyNormal::data_to_slot(data))
        (*static_cast<SlotType*>(slot))(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
}

static const Glib::SignalProxyInfo Drive_signal_unmounted_info =
{
  "volume-unmounted",
  (GCallback) &Drive_signal_unmounted_callback,
  (GCallback) &Drive_signal_unmounted_callback
};


} // anonymous namespace


namespace Glib
{

Glib::RefPtr<Gnome::Vfs::Drive> wrap(GnomeVFSDrive* object, bool take_copy)
{
  return Glib::RefPtr<Gnome::Vfs::Drive>( dynamic_cast<Gnome::Vfs::Drive*> (Glib::wrap_auto ((GObject*)(object), take_copy)) );
  //We use dynamic_cast<> in case of multiple inheritance.
}

} /* namespace Glib */


namespace Gnome
{

namespace Vfs
{


/* The *_Class implementation: */

const Glib::Class& Drive_Class::init()
{
  if(!gtype_) // create the GType if necessary
  {
    // Glib::Class has to know the class init function to clone custom types.
    class_init_func_ = &Drive_Class::class_init_function;

    // This is actually just optimized away, apparently with no harm.
    // Make sure that the parent type has been created.
    //CppClassParent::CppObjectType::get_type();

    // Create the wrapper type, with the same class/instance size as the base type.
    register_derived_type(gnome_vfs_drive_get_type());

    // Add derived versions of interfaces, if the C type implements any interfaces:
  }

  return *this;
}

void Drive_Class::class_init_function(void* g_class, void* class_data)
{
  BaseClassType *const klass = static_cast<BaseClassType*>(g_class);
  CppClassParent::class_init_function(klass, class_data);

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
  klass->volume_mounted = &volume_mounted_callback;
  klass->volume_pre_unmount = &volume_pre_unmount_callback;
  klass->volume_unmounted = &volume_unmounted_callback;
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
}

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED

#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void Drive_Class::volume_mounted_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj && obj->is_derived_())
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try // Trap C++ exceptions which would normally be lost because this is a C callback.
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      // Call the virtual member method, which derived classes might override.
      obj->on_mounted(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

    // Call the original underlying C function:
    if(base && base->volume_mounted)
      (*base->volume_mounted)(self, p0);
  }
}
void Drive_Class::volume_pre_unmount_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj && obj->is_derived_())
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try // Trap C++ exceptions which would normally be lost because this is a C callback.
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      // Call the virtual member method, which derived classes might override.
      obj->on_pre_unmount(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

    // Call the original underlying C function:
    if(base && base->volume_pre_unmount)
      (*base->volume_pre_unmount)(self, p0);
  }
}
void Drive_Class::volume_unmounted_callback(GnomeVFSDrive* self, GnomeVFSVolume* p0)
{
  CppObjectType *const obj = dynamic_cast<CppObjectType*>(
      Glib::ObjectBase::_get_current_wrapper((GObject*)self));

  // Non-gtkmmproc-generated custom classes implicitly call the default
  // Glib::ObjectBase constructor, which sets is_derived_. But gtkmmproc-
  // generated classes can use this optimisation, which avoids the unnecessary
  // parameter conversions if there is no possibility of the virtual function
  // being overridden:
  if(obj && obj->is_derived_())
  {
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    try // Trap C++ exceptions which would normally be lost because this is a C callback.
    {
    #endif //GLIBMM_EXCEPTIONS_ENABLED
      // Call the virtual member method, which derived classes might override.
      obj->on_unmounted(Glib::wrap(p0)
);
    #ifdef GLIBMM_EXCEPTIONS_ENABLED
    }
    catch(...)
    {
      Glib::exception_handlers_invoke();
    }
    #endif //GLIBMM_EXCEPTIONS_ENABLED
  }
  else
  {
    BaseClassType *const base = static_cast<BaseClassType*>(
        g_type_class_peek_parent(G_OBJECT_GET_CLASS(self)) // Get the parent class of the object class (The original underlying C class).
    );

    // Call the original underlying C function:
    if(base && base->volume_unmounted)
      (*base->volume_unmounted)(self, p0);
  }
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED


Glib::ObjectBase* Drive_Class::wrap_new(GObject* object)
{
  return new Drive((GnomeVFSDrive*)object);
}


/* The implementation: */

GnomeVFSDrive* Drive::gobj_copy()
{
  reference();
  return gobj();
}

Drive::Drive(const Glib::ConstructParams& construct_params)
:
  Glib::Object(construct_params)
{}

Drive::Drive(GnomeVFSDrive* castitem)
:
  Glib::Object((GObject*)(castitem))
{}

Drive::~Drive()
{}


Drive::CppClassType Drive::drive_class_; // initialize static member

GType Drive::get_type()
{
  return drive_class_.init().get_type();
}

GType Drive::get_base_type()
{
  return gnome_vfs_drive_get_type();
}


gulong Drive::get_id() const
{
  return gnome_vfs_drive_get_id(const_cast<GnomeVFSDrive*>(gobj()));
}

DeviceType Drive::get_device_type() const
{
  return (DeviceType)(gnome_vfs_drive_get_device_type(const_cast<GnomeVFSDrive*>(gobj())));
}

Glib::RefPtr<Volume> Drive::get_mounted_volume()
{

  Glib::RefPtr<Volume> retvalue = Glib::wrap(gnome_vfs_drive_get_mounted_volume(gobj()));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;

}

Glib::RefPtr<const Volume> Drive::get_mounted_volume() const
{

  Glib::RefPtr<const Volume> retvalue = Glib::wrap(gnome_vfs_drive_get_mounted_volume(const_cast<GnomeVFSDrive*>(gobj())));
  if(retvalue)
    retvalue->reference(); //The function does not do a ref for us.
  return retvalue;

}

Glib::ListHandle< Glib::RefPtr<Volume> > Drive::get_mounted_volumes()
{
  return Glib::ListHandle< Glib::RefPtr<Volume> >(gnome_vfs_drive_get_mounted_volumes(gobj()), Glib::OWNERSHIP_SHALLOW);
}

Glib::ListHandle< Glib::RefPtr<const Volume> > Drive::get_mounted_volumes() const
{
  return Glib::ListHandle< Glib::RefPtr<const Volume> >(gnome_vfs_drive_get_mounted_volumes(const_cast<GnomeVFSDrive*>(gobj())), Glib::OWNERSHIP_SHALLOW);
}

Glib::ustring Drive::get_device_path() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_vfs_drive_get_device_path(const_cast<GnomeVFSDrive*>(gobj())));
}

Glib::ustring Drive::get_activation_uri() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_vfs_drive_get_activation_uri(const_cast<GnomeVFSDrive*>(gobj())));
}

Glib::ustring Drive::get_display_name() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_vfs_drive_get_display_name(const_cast<GnomeVFSDrive*>(gobj())));
}

Glib::ustring Drive::get_icon() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_vfs_drive_get_icon(const_cast<GnomeVFSDrive*>(gobj())));
}

Glib::ustring Drive::get_hal_udi() const
{
  return Glib::convert_return_gchar_ptr_to_ustring(gnome_vfs_drive_get_hal_udi(const_cast<GnomeVFSDrive*>(gobj())));
}

bool Drive::is_user_visible() const
{
  return gnome_vfs_drive_is_user_visible(const_cast<GnomeVFSDrive*>(gobj()));
}

bool Drive::is_connected() const
{
  return gnome_vfs_drive_is_connected(const_cast<GnomeVFSDrive*>(gobj()));
}

bool Drive::is_mounted() const
{
  return gnome_vfs_drive_is_mounted(const_cast<GnomeVFSDrive*>(gobj()));
}

int Drive::compare(const Glib::RefPtr<const Drive>& a, const Glib::RefPtr<const Drive>& b)
{
  return gnome_vfs_drive_compare(const_cast<GnomeVFSDrive*>(Glib::unwrap(a)), const_cast<GnomeVFSDrive*>(Glib::unwrap(b)));
}


Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& > Drive::signal_mounted()
{
  return Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& >(this, &Drive_signal_mounted_info);
}


Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& > Drive::signal_pre_unmount()
{
  return Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& >(this, &Drive_signal_pre_unmount_info);
}


Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& > Drive::signal_unmounted()
{
  return Glib::SignalProxy1< void,const Glib::RefPtr<Volume>& >(this, &Drive_signal_unmounted_info);
}


#ifdef GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED
void Gnome::Vfs::Drive::on_mounted(const Glib::RefPtr<Volume>& volume)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->volume_mounted)
    (*base->volume_mounted)(gobj(),Glib::unwrap(volume));
}
void Gnome::Vfs::Drive::on_pre_unmount(const Glib::RefPtr<Volume>& volume)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->volume_pre_unmount)
    (*base->volume_pre_unmount)(gobj(),Glib::unwrap(volume));
}
void Gnome::Vfs::Drive::on_unmounted(const Glib::RefPtr<Volume>& volume)
{
  BaseClassType *const base = static_cast<BaseClassType*>(
      g_type_class_peek_parent(G_OBJECT_GET_CLASS(gobject_)) // Get the parent class of the object class (The original underlying C class).
  );

  if(base && base->volume_unmounted)
    (*base->volume_unmounted)(gobj(),Glib::unwrap(volume));
}
#endif //GLIBMM_DEFAULT_SIGNAL_HANDLERS_ENABLED

#ifdef GLIBMM_VFUNCS_ENABLED
#endif //GLIBMM_VFUNCS_ENABLED


} // namespace Vfs

} // namespace Gnome


